Skip to main content

Trie - Question 1

 Leetcode 421 Maximum XOR of Two Numbers in an Array

Given an integer array nums, return the maximum result of nums[i] XOR nums[j], where 0 <= i <= j < n.

Constraints:

1 <= nums.length <= 2 * 10^5

0 <= nums[i] <= 2^31 - 1


Analysis:

The naïve method is to use a two-layer for loop, to check every pair of numbers. The total time complexity is O(N^2), which  is too large since N could be 2*10^5.

There are methods to using the bit-wise operations directly, which will be discussed in the Bit Manipulation post. Here we will focus on the method using trie.

The key ideas are:

1. for each number, there are 32 bits. For each bit, only two possible values are available; thus we can build a binary trie to store all the numbers;

2. once the trie is built (the height is 32), we can iterate array, for each number we can check its 32 bits along with the trie layer by layer (32 layers). If the bit for the number is 1, we want to find the node with a bit value of 0 (why?  because we are search for 'exclusive or', and 1^0 gives 1. If the node does not exist, then this bit has to be 0. Similar argument can be applied to the case that the bit value is 0.

3. since we are looking for maximum, we need to start with the most significant bit.

4. since all the numbers' bits are stored in the trie,  for each number, we just need to check 32 bits of the number vs 32 layer of the trie. Or in 32 steps, we can obtain the maximum xor results between the current number with all the numbers in the array. Thus, the overall time complexity is O(32*N). 

See the code bleow:


class Solution {
struct node {
    vector<node*> ns;
    node() {
        ns.resize(2);
    }
};
public:
    int findMaximumXOR(vector<int>& nums) {
        node* root = new node();
        buildTree(root, nums);
        int res = INT_MIN;
        for(auto &a : nums) {
            res = max(res, findMax(a, root));
        }
        return res;
    }
private:
    void buildTree(node* root, vector<int>& nums) {
        for(auto &a : nums) {
            node* p = root;
            for(int i=31; i>=0; --i) {
                if(a>>i & 1) {
                    if(!p->ns[1]) p->ns[1] = new node();
                    p = p->ns[1];
                }
                else {
                    if(!p->ns[0]) p->ns[0] = new node();
                    p = p->ns[0];
                }
            }
        }
    }
    int findMax(int val, node* root) {
        int res = 0;
        node* p = root;
        for(int i=31; i>=0; --i) {
            if(val>>i & 1) {
                if(p->ns[0]) {
                    res |= 1<<i;
                    p = p->ns[0];
                }
                else p = p->ns[1];
            }
            else {
                if(p->ns[1]) {
                    res |= 1<<i;
                    p = p->ns[1];
                }
                else p = p->ns[0];
            }
        }
        return res;
    }
};


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...